summaryrefslogtreecommitdiffstats
path: root/tools
diff options
context:
space:
mode:
Diffstat (limited to 'tools')
-rwxr-xr-xtools/keystone_functional_tests.sh108
-rw-r--r--tools/test-requires1
2 files changed, 109 insertions, 0 deletions
diff --git a/tools/keystone_functional_tests.sh b/tools/keystone_functional_tests.sh
new file mode 100755
index 0000000..6acf24a
--- /dev/null
+++ b/tools/keystone_functional_tests.sh
@@ -0,0 +1,108 @@
+#!/bin/bash
+
+# Copyright (c) 2013 Red Hat, Inc.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
+# implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+# This program expects to be run by tox in a virtual python environment
+# so that it does not pollute the host development system
+
+sudo_env()
+{
+ sudo bash -c "PATH=$PATH $*"
+}
+
+cleanup()
+{
+ sudo service memcached stop
+ sudo_env swift-init main stop
+ sudo rm -rf /etc/swift > /dev/null 2>&1
+ for acct in /mnt/gluster-object/* ; do
+ sudo rm -rf /mnt/gluster-object/${acct}/* > /dev/null 2>&1
+ sudo setfattr -x user.swift.metadata /mnt/gluster-object/${acct} > /dev/null 2>&1
+ done
+}
+
+quit()
+{
+ echo "$1"
+ exit 1
+}
+
+
+fail()
+{
+ cleanup
+ quit "$1"
+}
+
+### MAIN ###
+
+# Only run if there is no configuration in the system
+if [ -x /etc/swift ] ; then
+ quit "/etc/swift exists, cannot run functional tests."
+fi
+
+# Check the directories exist
+DIRS="/mnt/gluster-object /mnt/gluster-object/test /mnt/gluster-object/test2 /mnt/gluster-object/gsmetadata"
+for d in $DIRS ; do
+ if [ ! -x $d ] ; then
+ quit "$d must exist on an XFS or GlusterFS volume"
+ fi
+done
+
+# Check if keystone is running on this host
+if ! ps -ef | grep keystone | grep python > /dev/null 2>&1 ; then
+ fail "Keystone is not running on localhost"
+fi
+
+export SWIFT_TEST_CONFIG_FILE=/etc/swift/test.conf
+
+# Install the configuration files
+sudo mkdir /etc/swift > /dev/null 2>&1
+sudo cp -r test/functional_auth/keystone/conf/* /etc/swift || fail "Unable to copy configuration files to /etc/swift"
+
+# Create the ring files according to any directories
+# in /mnt/gluster-object since the script can't
+# interrogate keystone to get the tenant-id's
+accounts=""
+for acct in /mnt/gluster-object/* ; do
+ acct=`basename $acct`
+ accounts="$acct $accounts"
+done
+sudo_env gluster-swift-gen-builders $accounts || fail "Unable to create ring files"
+
+# Start the services
+sudo service memcached start || fail "Unable to start memcached"
+sudo_env swift-init main start || fail "Unable to start swift"
+
+mkdir functional_tests > /dev/null 2>&1
+
+echo "== Keystone: Generic Functional Tests =="
+
+nosetests -v --exe \
+ --with-xunit \
+ --xunit-file functional_tests/gluster-swift-keystone-generic-functional-TC-report.xml \
+ --with-html-output \
+ --html-out-file functional_tests/gluster-swift-keystone-generic-functional-result.html \
+ test/functional || fail "Functional tests failed"
+nosetests -v --exe \
+ --with-xunit \
+ --xunit-file functional_tests/gluster-swift-keystone-functionalnosetests-TC-report.xml \
+ --with-html-output \
+ --html-out-file functional_tests/gluster-swift-keystone-functionalnosetests-result.html \
+ test/functionalnosetests || fail "Functional-nose tests failed"
+
+cleanup
+exit 0
diff --git a/tools/test-requires b/tools/test-requires
index fdebbb6..874e96f 100644
--- a/tools/test-requires
+++ b/tools/test-requires
@@ -10,3 +10,4 @@ openstack.nose_plugin
nosehtmloutput
sphinx>=1.1.2
mock>=0.8.0
+python-keystoneclient